/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.fel.k333.jerseytest.rest;

import cz.fel.k333.jerseytest.Person;
import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.MediaType;

/**
 *
 * @author zdenekkouba
 */
@Path("/person")
public class JSONService {

    @GET
    @Path("/new")
    @Produces(MediaType.APPLICATION_JSON)
    public Person getPersonAsObject() {
        System.out.println("getPersonInJSON called");
        Person person = new Person();
        person.setGivenName("Jan");
        person.setFamilyName("Novak");

        return person;

    }
    
    @GET
    @Path("/textpath/{given_name}/{family_name}")
    @Produces(MediaType.APPLICATION_JSON)
    public Person getPersonAsText(@PathParam("given_name") String gName, @PathParam("family_name") String fName) {
        Person person = new Person();
        person.setGivenName(gName);
        person.setFamilyName(fName);
        return person;
    }
 
    @GET
    @Path("/textparam")
    @Produces(MediaType.APPLICATION_JSON)
    public Person getPersonAsTextParam(@QueryParam("given_name") String gName, @QueryParam("family_name") String fName) {
        Person person = new Person();
        person.setGivenName(gName);
        person.setFamilyName(fName);
        return person;
    }
 
    
    @POST
    @Path("/rename/{newGName}/{newFName}")
    @Consumes(MediaType.APPLICATION_JSON)
    @Produces(MediaType.APPLICATION_JSON)
    public Person rename(@PathParam("newGName") String newGName, 
                         @PathParam("newFName") String newFName,
                         Person person) {
        person.setGivenName(newGName);
        person.setFamilyName(newFName);
        return person;
    }
    
    
}
